diff --git a/src/main/java/net/minecraft/server/net/ConsoleCommandHandler.java b/src/main/java/net/minecraft/server/net/ConsoleCommandHandler.java
index ba3bee281..03e0281b9 100644
--- a/src/main/java/net/minecraft/server/net/ConsoleCommandHandler.java
+++ b/src/main/java/net/minecraft/server/net/ConsoleCommandHandler.java
@@ -1,35 +1,19 @@
 package net.minecraft.server.net;
 
-import java.util.Iterator;
-import java.util.Set;
 
+import net.minecraft.core.net.ServerCommandEntry;
 
-import net.minecraft.core.net.ICommandListener;
-import net.minecraft.core.net.ServerCommand;
-import net.minecraft.server.entity.player.EntityPlayerMP;
-import net.minecraft.core.net.packet.Packet3Chat;
-import net.minecraft.core.net.packet.Packet41EntityPlayerGamemode;
-import net.minecraft.core.player.gamemode.Gamemode;
-import net.minecraft.server.world.WorldServer;
 import net.minecraft.server.MinecraftServer;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.net.command.Command;
 import net.minecraft.core.net.command.CommandError;
 import net.minecraft.core.net.command.Commands;
 import net.minecraft.core.net.command.ConsoleCommandSender;
-import org.apache.log4j.Logger;
-
-
-// Referenced classes of package net.minecraft.src:
-//            ServerCommand, ICommandListener, ServerConfigurationManager, WorldServer, 
-//            EntityPlayerMP, NetServerHandler, Item, ItemStack, 
-//            Packet3Chat, PropertyManager
 
 public class ConsoleCommandHandler
 {
 
-    private static Logger minecraftLogger = Logger.getLogger("Minecraft");
-    private MinecraftServer minecraftServer;
+    private final MinecraftServer minecraftServer;
     public final ConsoleCommandSender sender;
 
     public ConsoleCommandHandler(MinecraftServer server)
@@ -41,10 +25,10 @@ public class ConsoleCommandHandler
         this.sender = new ConsoleCommandSender(server);
     }
 
-    public boolean handleCommandNew(ServerCommand serverCommand) {
-    	System.out.println("ServerCommand: "+serverCommand.command);
+    public void handleCommand(ServerCommandEntry serverCommandEntry) {
+    	System.out.println("ServerCommand: "+ serverCommandEntry.command);
 
-    	String[] args = serverCommand.command.split(" ");
+    	String[] args = serverCommandEntry.command.split(" ");
     	String[] args1 = new String[args.length - 1];
     	System.arraycopy(args, 1, args1, 0, args.length - 1);
 
@@ -58,258 +42,9 @@ public class ConsoleCommandHandler
     			}catch (CommandError e) {
     				sender.sendMessage(TextFormatting.RED + e.getMessage());
 				}
-    			return true;
+    			return;
     		}
     	}
         sender.sendMessage(TextFormatting.RED + "Command '" + args[0] + "' does not exist!");
-    	
-    	return false;
-    }
-
-    public void handleCommand(ServerCommand servercommand)
-    {
-        String s = servercommand.command;
-        ICommandListener icommandlistener = servercommand.commandListener;
-        String s1 = icommandlistener.getUsername();
-        PlayerList serverconfigurationmanager = minecraftServer.playerList;
-        if(handleCommandNew(servercommand)) {} else
-        if(s.toLowerCase().startsWith("help") || s.toLowerCase().startsWith("?"))
-        {
-            printHelp(icommandlistener);
-        } else
-        if(s.toLowerCase().startsWith("save-all"))
-        {
-            sendNoticeToOps(s1, "Forcing save..");
-            if(serverconfigurationmanager != null)
-            {
-                serverconfigurationmanager.savePlayerStates();
-            }
-            for(int i = 0; i < minecraftServer.dimensionWorlds.length; i++)
-            {
-                WorldServer worldserver = minecraftServer.dimensionWorlds[i];
-                worldserver.saveWorld(true, null, i == 0);
-            }
-
-            sendNoticeToOps(s1, "Save complete.");
-        } else
-        if(s.toLowerCase().startsWith("save-off"))
-        {
-            sendNoticeToOps(s1, "Disabling level saving..");
-            for(int j = 0; j < minecraftServer.dimensionWorlds.length; j++)
-            {
-                WorldServer worldserver1 = minecraftServer.dimensionWorlds[j];
-                worldserver1.levelSaving = true;
-            }
-
-        } else
-        if(s.toLowerCase().startsWith("save-on"))
-        {
-            sendNoticeToOps(s1, "Enabling level saving..");
-            for(int k = 0; k < minecraftServer.dimensionWorlds.length; k++)
-            {
-                WorldServer worldserver2 = minecraftServer.dimensionWorlds[k];
-                worldserver2.levelSaving = false;
-            }
-
-        } else
-        if(s.toLowerCase().startsWith("ban-ip "))
-        {
-            String s4 = s.substring(s.indexOf(" ")).trim();
-            serverconfigurationmanager.banIP(s4);
-            sendNoticeToOps(s1, (new StringBuilder()).append("Banning ip ").append(s4).toString());
-        } else
-        if(s.toLowerCase().startsWith("pardon-ip "))
-        {
-            String s5 = s.substring(s.indexOf(" ")).trim();
-            serverconfigurationmanager.pardonIP(s5);
-            sendNoticeToOps(s1, (new StringBuilder()).append("Pardoning ip ").append(s5).toString());
-        } else
-        if(s.toLowerCase().startsWith("ban "))
-        {
-            String s6 = s.substring(s.indexOf(" ")).trim();
-            serverconfigurationmanager.banPlayer(s6);
-            sendNoticeToOps(s1, (new StringBuilder()).append("Banning ").append(s6).toString());
-            EntityPlayerMP entityplayermp = serverconfigurationmanager.getPlayerEntity(s6);
-            if(entityplayermp != null)
-            {
-                entityplayermp.playerNetServerHandler.kickPlayer("Banned by admin");
-            }
-        } else
-        if(s.toLowerCase().startsWith("pardon "))
-        {
-            String s7 = s.substring(s.indexOf(" ")).trim();
-            serverconfigurationmanager.pardonPlayer(s7);
-            sendNoticeToOps(s1, (new StringBuilder()).append("Pardoning ").append(s7).toString());
-        } else
-        if(s.toLowerCase().startsWith("kick "))
-        {
-            String s8 = s.substring(s.indexOf(" ")).trim();
-            EntityPlayerMP entityplayermp1 = null;
-            for(int l = 0; l < serverconfigurationmanager.playerEntities.size(); l++)
-            {
-                EntityPlayerMP entityplayermp5 = (EntityPlayerMP)serverconfigurationmanager.playerEntities.get(l);
-                if(entityplayermp5.username.equalsIgnoreCase(s8))
-                {
-                    entityplayermp1 = entityplayermp5;
-                }
-            }
-
-            if(entityplayermp1 != null)
-            {
-                entityplayermp1.playerNetServerHandler.kickPlayer("Kicked by admin");
-                sendNoticeToOps(s1, (new StringBuilder()).append("Kicking ").append(entityplayermp1.getDisplayName()).toString());
-            } else
-            {
-                icommandlistener.log((new StringBuilder()).append("Can't find user ").append(s8).append(". No kick.").toString());
-            }
-        } else
-        if(s.toLowerCase().startsWith("say "))
-        {
-            s = s.substring(s.indexOf(" ")).trim();
-            minecraftLogger.info((new StringBuilder()).append("[").append(s1).append("] ").append(s).toString());
-            serverconfigurationmanager.sendPacketToAllPlayers(new Packet3Chat((new StringBuilder()).append(TextFormatting.PINK + "[Server] ").append(s).toString()));
-        } else
-        if(s.toLowerCase().startsWith("whitelist "))
-        {
-            handleWhitelist(s1, s, icommandlistener);
-        }
-        else if (s.startsWith("gamemode "))
-        {
-        	String as[] = s.split(" ");
-        	if (as.length == 3)
-        	{
-        		int gamemodeId = -1;
-        		try
-        		{
-        			gamemodeId = Integer.parseInt(as[2]);
-        		}
-        		catch (Exception e)
-        		{
-                    icommandlistener.log("Unknown or invalid gamemode ID.");
-        		}
-        		
-        		if (gamemodeId != -1)
-        		{
-        			if (gamemodeId >= Gamemode.gamemodesList.length || Gamemode.gamemodesList[gamemodeId] == null)
-        			{
-                        icommandlistener.log("Unknown or invalid gamemode ID.");
-        			}
-        			else
-        			{
-
-                        EntityPlayerMP player = serverconfigurationmanager.getPlayerEntity(as[1]);
-                        if(player == null)
-                        {
-                            icommandlistener.log("There's no player by that name online.");
-                        }
-                        else
-                        {
-                        	player.setGamemode(Gamemode.gamemodesList[gamemodeId]);
-                            sendNoticeToOps(s1, (new StringBuilder()).append("Setting ").append(player.getDisplayName()).append("\2477").append("'s gamemode to ").append(Gamemode.gamemodesList[gamemodeId].getLanguageKey()).toString());
-                        }
-        			}
-        		}
-        	}
-        }
-        else
-        {
-            minecraftLogger.info("Unknown console command. Type \"help\" for help.");
-        }
-    }
-
-    private void handleWhitelist(String s, String s1, ICommandListener icommandlistener)
-    {
-        String as[] = s1.split(" ");
-        if(as.length < 2)
-        {
-            return;
-        }
-        String s2 = as[1].toLowerCase();
-        if("on".equals(s2))
-        {
-            sendNoticeToOps(s, "Turned on white-listing");
-            minecraftServer.propertyManager.setProperty("white-list", true);
-        } else
-        if("off".equals(s2))
-        {
-            sendNoticeToOps(s, "Turned off white-listing");
-            minecraftServer.propertyManager.setProperty("white-list", false);
-        } else
-        if("list".equals(s2))
-        {
-            Set set = minecraftServer.playerList.getWhitelist();
-            String s5 = "";
-            for(Iterator iterator = set.iterator(); iterator.hasNext();)
-            {
-                String s6 = (String)iterator.next();
-                s5 = (new StringBuilder()).append(s5).append(s6).append(" ").toString();
-            }
-
-            icommandlistener.log((new StringBuilder()).append("White-listed players: ").append(s5).toString());
-        } else
-        if("add".equals(s2) && as.length == 3)
-        {
-            String s3 = as[2].toLowerCase();
-            minecraftServer.playerList.addToWhiteList(s3);
-            sendNoticeToOps(s, (new StringBuilder()).append("Added ").append(s3).append(" to white-list").toString());
-        } else
-        if("remove".equals(s2) && as.length == 3)
-        {
-            String s4 = as[2].toLowerCase();
-            minecraftServer.playerList.removeFromWhiteList(s4);
-            sendNoticeToOps(s, (new StringBuilder()).append("Removed ").append(s4).append(" from white-list").toString());
-        } else
-        if("reload".equals(s2))
-        {
-            minecraftServer.playerList.reloadWhiteList();
-            sendNoticeToOps(s, "Reloaded white-list from file");
-        }
     }
-
-    private void printHelp(ICommandListener icommandlistener)
-    {
-        icommandlistener.log("To run the server without a gui, start it like this:");
-        icommandlistener.log("   java -Xmx1024M -Xms1024M -jar minecraft_server.jar nogui");
-        icommandlistener.log("Console commands:");
-        icommandlistener.log("   help  or  ?               shows this message");
-        icommandlistener.log("   kick <player>             removes a player from the server");
-        icommandlistener.log("   ban <player>              bans a player from the server");
-        icommandlistener.log("   pardon <player>           pardons a banned player so that they can connect again");
-        icommandlistener.log("   ban-ip <ip>               bans an IP address from the server");
-        icommandlistener.log("   pardon-ip <ip>            pardons a banned IP address so that they can connect again");
-        icommandlistener.log("   op <player>               turns a player into an op");
-        icommandlistener.log("   deop <player>             removes op status from a player");
-        icommandlistener.log("   tp <player1> <player2>    moves one player to the same location as another player");
-        icommandlistener.log("   give <player> <id> [num]  gives a player a resource");
-        icommandlistener.log("   tell <player> <message>   sends a private message to a player");
-        icommandlistener.log("   stop                      gracefully stops the server");
-        icommandlistener.log("   save-all                  forces a server-wide level save");
-        icommandlistener.log("   save-off                  disables terrain saving (useful for backup scripts)");
-        icommandlistener.log("   save-on                   re-enables terrain saving");
-        icommandlistener.log("   list                      lists all currently connected players");
-        icommandlistener.log("   say <message>             broadcasts a message to all players");
-        icommandlistener.log("   time <add|set> <amount>   adds to or sets the world time (0-24000)");
-        icommandlistener.log("   gamemode <player> <id>   sets the target player's gamemode");
-        icommandlistener.log("   setspawn <x> <y> <z>   sets the server spawn point to the given coordinates");
-    }
-
-    private void sendNoticeToOps(String s, String s1)
-    {
-        String s2 = (new StringBuilder()).append(s).append(": ").append(s1).toString();
-        minecraftServer.playerList.sendChatMessageToAllOps((new StringBuilder()).append("\2477(").append(s2).append(")").toString());
-        minecraftLogger.info(s2);
-    }
-
-    private int tryParse(String s, int i)
-    {
-        try
-        {
-            return Integer.parseInt(s);
-        }
-        catch(NumberFormatException numberformatexception)
-        {
-            return i;
-        }
-    }
-
 }
diff --git a/src/main/java/net/minecraft/server/net/NetworkListenThread.java b/src/main/java/net/minecraft/server/net/NetworkListenThread.java
index 9bc07d6f1..f781fe02f 100644
--- a/src/main/java/net/minecraft/server/net/NetworkListenThread.java
+++ b/src/main/java/net/minecraft/server/net/NetworkListenThread.java
@@ -5,17 +5,16 @@ import java.net.InetAddress;
 import java.net.ServerSocket;
 import java.net.Socket;
 import java.util.ArrayList;
-import java.util.HashMap;
 
 
-import net.minecraft.server.net.handler.NetLoginHandler;
-import net.minecraft.server.net.handler.NetServerHandler;
+import net.minecraft.server.net.handler.LoginPacketHandler;
+import net.minecraft.server.net.handler.ServerPacketHandler;
 import net.minecraft.server.MinecraftServer;
 import org.apache.log4j.Logger;
 
 
 // Referenced classes of package net.minecraft.src:
-//            NetworkAcceptThread, NetLoginHandler, NetworkManager, NetServerHandler
+//            NetworkAcceptThread, LoginPacketHandler, NetworkManager, ServerPacketHandler
 
 public class NetworkListenThread
 {
@@ -36,7 +35,7 @@ public class NetworkListenThread
                 try {
                     Socket socket = serverSocket.accept();
                     if (socket != null) {
-                        NetLoginHandler loginHandler = new NetLoginHandler(mcServer, socket, "Connection #" + connectionCounter++);
+                        LoginPacketHandler loginHandler = new LoginPacketHandler(mcServer, socket, "Connection #" + connectionCounter++);
                         addPendingConnection(loginHandler);
                     }
                 } catch (IOException ioexception) {
@@ -47,12 +46,12 @@ public class NetworkListenThread
         networkAcceptThread.start();
     }
 
-    public void addPlayer(NetServerHandler netserverhandler)
+    public void addPlayer(ServerPacketHandler netserverhandler)
     {
         playerList.add(netserverhandler);
     }
 
-    private void addPendingConnection(NetLoginHandler netloginhandler)
+    private void addPendingConnection(LoginPacketHandler netloginhandler)
     {
         if(netloginhandler == null)
         {
@@ -68,7 +67,7 @@ public class NetworkListenThread
     {
         for(int i = 0; i < pendingConnections.size(); i++)
         {
-            NetLoginHandler netloginhandler = pendingConnections.get(i);
+            LoginPacketHandler netloginhandler = pendingConnections.get(i);
             try
             {
                 netloginhandler.tryLogin();
@@ -87,7 +86,7 @@ public class NetworkListenThread
 
         for(int j = 0; j < playerList.size(); j++)
         {
-            NetServerHandler netserverhandler = (NetServerHandler)playerList.get(j);
+            ServerPacketHandler netserverhandler = (ServerPacketHandler)playerList.get(j);
             try
             {
                 netserverhandler.handlePackets();
@@ -111,8 +110,8 @@ public class NetworkListenThread
     private Thread networkAcceptThread;
     public volatile boolean isListening;
     private int connectionCounter;
-    private ArrayList<NetLoginHandler> pendingConnections;
-    private final ArrayList<NetServerHandler> playerList;
+    private ArrayList<LoginPacketHandler> pendingConnections;
+    private final ArrayList<ServerPacketHandler> playerList;
     public MinecraftServer mcServer;
 
 }
diff --git a/src/main/java/net/minecraft/core/player/PlayerHash.java b/src/main/java/net/minecraft/server/net/PlayerHash.java
similarity index 99%
rename from src/main/java/net/minecraft/core/player/PlayerHash.java
rename to src/main/java/net/minecraft/server/net/PlayerHash.java
index 47f74a21f..2f091caf9 100644
--- a/src/main/java/net/minecraft/core/player/PlayerHash.java
+++ b/src/main/java/net/minecraft/server/net/PlayerHash.java
@@ -1,4 +1,4 @@
-package net.minecraft.core.player;
+package net.minecraft.server.net;
 
 
 // Referenced classes of package net.minecraft.src:
diff --git a/src/main/java/net/minecraft/core/player/PlayerHashEntry.java b/src/main/java/net/minecraft/server/net/PlayerHashEntry.java
similarity index 97%
rename from src/main/java/net/minecraft/core/player/PlayerHashEntry.java
rename to src/main/java/net/minecraft/server/net/PlayerHashEntry.java
index 433ab07b4..42ff0829f 100644
--- a/src/main/java/net/minecraft/core/player/PlayerHashEntry.java
+++ b/src/main/java/net/minecraft/server/net/PlayerHashEntry.java
@@ -1,4 +1,4 @@
-package net.minecraft.core.player;
+package net.minecraft.server.net;
 
 
 // Referenced classes of package net.minecraft.src:
